<?php
   /* First 60% lent from Budabot
   ** (http://sourceforge.net/projects/budabot)
   ** Author: Derroylo (RK2)
   ** Description: Shows status of a TS Server
   */
if ($pluginwords[1]=="!ts") {
	global $myguild;
	$msg = "";

	//TS Server Info
	$ip 		= "";    #ip of your teamspeak server
	$queryport 	= 12345; #your teamspeak-telnet port (not the port for TS clients), see your server.ini
	$serverport 	= 8767;  #port for your TS clients
	$servername 	= "Ragebot"; #name of your teamspeakserver

  	//Try to connect to TS Server (with timeout)
	$timeToEnd = (time() + 5);
	$connection = fsockopen($ip, $queryport, $errno, $errstr, 30);
	if($connection) {
		$infolines = "";
		fputs($connection,"sel ".$serverport."\n");
		fputs($connection,"si\n");
		fputs($connection,"quit\n");

		while(!feof($connection)){
			$infolines .= fgets($connection, 1024);
		}
		fclose($connection);
		$infolines = str_replace("[TS]","",$infolines);
		$infolines = str_replace("OK","",$infolines);
		$infolines = trim($infolines);

		//Connected Users
		$indexof = strpos($infolines, "server_currentusers=") + strlen("server_currentusers=");
		$user = substr($infolines, $indexof, strlen($infolines));
		$indexof = strpos($user, "server_currentchannels=") + strlen("server_currentchannels=");
		$user = substr($user, 0, $indexof - strlen("server_currentchannels="));
		$user = trim($user);

		//Server Max Users
		$indexof = strpos($infolines, "server_maxusers=") + strlen("server_maxusers=");
		$maxusers = substr($infolines, $indexof, strlen($infolines));
		
		$indexof = strpos($maxusers, "server_allow_codec_celp51=") + strlen("server_allow_codec_celp51=");
		$maxusers = substr($maxusers, 0, $indexof - strlen("server_allow_codec_celp51="));
   		$maxusers = trim($maxusers);

		//Uptime of the Server
		$indexof = strpos($infolines, "server_uptime=") + strlen("server_uptime=");
   		$uptime = substr($infolines, $indexof, strlen($infolines));
		$indexof = strpos($uptime, "server") + strlen("server_currrentusers=");
		$uptime = substr($uptime, 0, $indexof - strlen("server_currrentusers="));
   		$uptime = trim($uptime);
		$hours = floor($uptime/3600);
	   	$minutes = floor(($uptime%3600)/60);
	   	$seconds = floor(($uptime%3600)%60);
		if($hours>0) $uptime = $hours."h ".$minutes."m ".$seconds."s";
		else if($minutes>0) $uptime = $minutes."m ".$seconds."s";
		else $uptime = $seconds."s";		
		
		//Serverplatform
		$indexof = strpos($infolines, "server_platform=") + strlen("server_platform=");
		$platform = substr($infolines, $indexof, strlen($infolines));
		$indexof = strpos($platform, "server_welcomemessage=") + strlen("server_welcomemessage=");
		$platform = substr($platform, 0, $indexof - strlen("server_welcomemessage="));
   		$platform = trim($platform);
		
		//Number of channels
		$indexof = strpos($infolines, "server_currentchannels=") + strlen("server_currentchannels=");
   		$channels = substr($infolines, $indexof, strlen($infolines));
		$indexof = strpos($channels, "server_bwinlastsec=") + strlen("server_bwinlastsec=");
		$channels = substr($channels, 0, $indexof - strlen("server_bwinlastsec="));
  		$channels = trim($channels);
		
		$link  = colortext("::::: Teamspeak Server Info :::::")."\n\n";
	
		//Get Players
		$player_array = array();
		$innerArray = array();
		$out	= "";
		$j	= 0; 
		$k	= 0;
	
		$connection = fsockopen($ip, $queryport, $errno, $errstr, 30);
		fputs($connection, "pl ".$serverport."\n");		
		fputs($connection, "quit\n");
		while(!feof($connection))
			$out .= fgets($connection, 1024);
		$out   = str_replace("[TS]", "", $out);
		$out   = str_replace("loginname", "loginname\t", $out);		
		$data 	= explode("\t", $out);
		$num 	= count($data);				
			
		for($i = 0; $i < count($data); $i++) {
			$innerArray[$j] = $data[$i];
			if($j >= 15) {
				$player_array[$k] = $innerArray;
				$j = 0;
				$k = $k + 1;
			} else
				$j++;
		}			
		fclose($connection);

		//Get Channels
		$cArray = array();
		$innerArray = array();	
		$out	= "";
		$j	= 0; 
		$k	= 0;
		
		$connection = fsockopen($ip, $queryport, $errno, $errstr, 30);
		fputs($connection, "cl ".$serverport."\n");		
		fputs($connection, "quit\n");
		while(!feof($connection)) {
			$out .= fgets($connection, 1024);
		}
		$out   = str_replace("[TS]", "", $out);
		$out   = str_replace("\n", "\t", $out);			
		$data 	= explode("\t", $out);
		$num 	= count($data);				
		
		for($i=0;$i<count($data);$i++) {
			if($i>=10) {
				$innerArray[$j] = $data[$i];
				if($j>=8) {
					$cArray[$k]=$innerArray;
					$j = 0;
					$k = $k+1;
				} else
					$j++;
			}			
		}			
		fclose($connection);

		# Chaly starts
		# Pls sort the channels -.-
		$cOrderP=array(); foreach($cArray as $E) $cOrderP[]=$E[3]; #sort on TS sortkey
		$cOrderS=array(); foreach($cArray as $E) $cOrderS[]=$E[5];  #on same TS sortkeys sort by name
		array_multisort($cOrderP,SORT_ASC,$cOrderS,SORT_ASC,$cArray);
		# Create parents & childs
		$printchannel=create_function('$channel,$players,$first','
			if ($first) {
				$out="<font color=#10FA30><u>".
				  strtr($channel[5],array("\""=>"",">"=>"&gt;","<"=>"&lt;",""=>"ae",""=>"oe",""=>"ue",""=>"Ae",""=>"Oe",""=>"Ue",""=>"ss")).
				  "</u></font>"."\n";
			} else {
				$out="&nbsp;&nbsp;&nbsp;<font color=#20F080>".
				  strtr($channel[5],array("\""=>"",">"=>"&gt;","<"=>"&lt;",""=>"ae",""=>"oe",""=>"ue",""=>"Ae",""=>"Oe",""=>"Ue",""=>"ss")).
				  "</font>\n";
			}
			$out_p="<font color=#A0E0A8>";
			$numplayer=0;
		  	foreach($players as $player) if($player[1] == $channel[0]) {
				$numplayer++;
				if (!$first) $out_p.="&nbsp;&nbsp;";
				$out_p.="&nbsp;&nbsp;".
				  strtr($player[14],array("\""=>"",">"=>"&gt;","<"=>"&lt;",""=>"ae",""=>"oe",""=>"ue",""=>"Ae",""=>"Oe",""=>"Ue",""=>"ss")).
				  "\n";
			}
			$out_p.="</font>";
			if ($numplayer) return $out.$out_p; else return $out;
			');
		foreach ($cArray as $channel) if ($channel[2]==-1) {
			$link.=$printchannel($channel,$player_array,true);
			foreach ($cArray as $subchannel) if ($subchannel[2]==$channel[0]) {
				$link.=$printchannel($subchannel,$player_array,false);
			}
		}
		unset($printchannel);

		#minimal statistics here..
		$link .= colortext("\n\n<u>General Info about the TS Server</u>\n").
			"<font color=#20F080>".
			"Server IP: $ip\n".
			"Server Name: $servername\n".
			"Server Uptime: $uptime\n".
			"Players Connected: $user\n".
			"Server Channels: $channels\n".
			"</font>";

		$msg = makelink(":: Teamspeak Server Status ::",$link);
	} else {
		$msg = "Teamspeak seem to be down.";
	}
	send_public_channel_message($myguild,$msg);
}#if ($pluginwords[1]=="!ts")

?>