<?php
global $myname;
if ($sender!=$myname) {
	global $guildmates,$guildmains,$AOC;
	/* Handle adding guildmates to buddylist*/
	if (!$AOC->buddy_exists($sender)) {
		say("New guilmate for buddylist:".$sender);
		$AOC->buddy_add($sender);
	}
	/*Remember buddy talked with my guild*/
	$guildmates[$sender]=time();


	/*check if user wants to add a mainchar*/
	if ($pluginwords[1]=="!main" && $guildmains) {
		if ($pluginwords[2]!="") {
			$mainchar=strtr($pluginwords[2],array("\""=>"",">"=>"&gt;","<"=>"&lt;",""=>"ae",""=>"oe",""=>"ue",""=>"Ae",""=>"Oe",""=>"Ue",""=>"ss"));
			$mainchar=strtoupper(substr($mainchar,0,1)).substr($mainchar,1);
			#the bot has to "know" the main character ("know": the main character must have been already logged in and talked to the guildchannel.. -.-)
			if ($guildmates[$mainchar]) {
				$guildmains[$sender]=$mainchar;
				$msg=colortext(":: $sender :: $mainchar is now your main. ::");
			} else {
				$helptext=colortext("::::: Help for adding a main character :::::")."\n\n".
				  "If $mainchar wasn't misspelled, i don't know your main character yet.\n\n".
				  "This can happen if you never logged in your main character and talked with your guild since i'm online.\n".
				  "<font color=#30F040>Please login your main character and say a word in the guildchannel.</font>\n\n".
				  "As long as there is no guildmember list provided for me, there's no other way...";
				$msg=colortext(":: $sender :: Sorry, i don't know $mainchar. ::")." ".makelink("(Click here for help)",$helptext);
			}
		} elseif ($guildmains[$sender]) {
			$guildmains[$sender]=false;
			$msg=colortext(":: $sender :: Your main was removed. ::");
		} else {
			$msg=colortext(":: $sender :: Invalid syntax. Use: !main (name of your main character) ::");
		}
		send_guild_channel_message($msg);
	}


	/*check if $sender wants to add an $guildmates[$mainchar]*/
	if (($pluginwords[1]=="!alt"||$pluginwords[1]=="!twink") && $guildmains) {
		if ($pluginwords[2]!="") {
			$altchar=strtr($pluginwords[2],array("\""=>"",">"=>"&gt;","<"=>"&lt;",""=>"ae",""=>"oe",""=>"ue",""=>"Ae",""=>"Oe",""=>"Ue",""=>"ss"));
			$altchar=strtoupper(substr($altchar,0,1)).substr($altchar,1);
			#we won't check if the bot already knows the alt to let people add
			#their 912873 alts without having to log them in and talk to the guildchannel first
			if (!$guildmains[$altchar]) {
				$guildmains[$altchar]=$sender;
				$msg=colortext(":: $sender :: ".$altchar." is now marked as your twink ::");
			} elseif ($guildmains[$altchar]==$sender) {
				$guildmains[$altchar]=false;
				$msg=colortext(":: $sender :: ".$altchar." is no longer marked as your twink ::");
			} else {
				$msg=colortext(":: $sender :: ".$altchar." is the alt of ".$guildmains[$altchar]."! ::");
			}
		} else {
			$msg=colortext(":: $sender :: Invalid syntax. Use: !alt (name of your alt) ::");
		}
		send_guild_channel_message($msg);
	}

	/*check if the user wants to view all twinks..*/
	if ($pluginwords[1]=="!twinklist") {
		global $admins;	
		#a little sorting first..
		$guildmainssorted=$guildmains;
		asort($guildmainssorted);

		#make the blobs..
		$helptext=colortext("::::: Twinks :::::")."\n";
		if (in_array($sender,$admins))
			$adminhelp="\n\nHey, you're my master!\n<u>Twink administration:</u>\n/tell $myname !twinkadmin\n";
		else
			$adminhelp="";
		$n=0; $i=0;
		$lastmain="";
		foreach ($guildmainssorted as $altchar=>$mainchar) if ($altchar!==0) {
			if ($lastmain!=$mainchar) {
				$lastmain=$mainchar;
				$helptext.="\n<font color=#30F040>$mainchar:</font> $altchar";
			} else {
				$helptext.=", $altchar";
			}
			$n++; $i++;
			#make a tell every 15 twinks 
			if ($n>=15) {
				$msg=makelink("$n twinks found.",$helptext.$adminhelp);
				send_private_tell($sender,$msg);
				$n=0;
				$helptext=colortext("::::: Twinks :::::")."\n";
			}
		}
		if ($n>0) {
			$msg=makelink("$n twinks found.",$helptext.$adminhelp);
			send_private_tell($sender,$msg);
		}

		#inform the guildchannel ..
		if ($i>0) {
			$msg=colortext(":: $sender :: I know $i twinks. You've got a tell with the details ::");
		} else  {
			$msg=colortext(":: $sender :: There's no twink yet. Use !main or !alt to define some ::");
		}
		send_guild_channel_message($msg);
	}
}
?>